////////////////////////////////////////////////////////////////////////////////////
//DuckShoot!
//by Roel Smit,
//made with 3dgamestudio 6.506 commercial
////////////////////////////////////////////////////////////////////////////////////
//add relative paths
path "levels";
path "models";
path "artwork";
path "sound";
////////////////////////////////////////////////////////////////////////////////////
//prototypes
function loop_create_ducks();
function loop_gameover();
function loop_camera();
//some vars
var video_mode = 7;
var video_screen = 1;
var fps_max = 80;
var fps_min = 10;
var trace_from[3];
var trace_to[3];
var cam2visibility;
var right_loaded;
var lives = 5;
var score = 0;
var savescore;
var difficulty = 1;
var_nsave music_handle;
//string for burning entities
string burn_cmp_str;
//pointers
entity* close_ent;
//bitmaps
BMAP LOGODARK_bmap = "LOGODARK.PCX";
BMAP CROSSHAIR_bmap = "CROSSHAIR.BMP";
BMAP FIRE_bmap = "FIRE.TGA";
BMAP SMOKE_BLACK_bmap = "SMOKE_BLACK.TGA";
BMAP BLACKMAP_bmap = "BLACKMAP.BMP";
BMAP HEART_bmap = "HEART.tga";
// Font generated by A4 Font Generator, Neonlite Software
font DuckFont = "DuckFont.tga", 24, 29;
//models, sprites
string duck_mdl = <duck.mdl>;
string bullet_mdl = <bullet1.mdl>;
string car_mdl		= <traffic_car1.mdl>;
string gib_mdl = <gib.mdl>;
//midi
string song0_mid = <song_0.mid>;
string song1_mid = <song_1.mid>;
string song2_mid = <song_2.mid>;
//sounds
sound hit_1_wav = <hit_1.wav>;
sound explo_3_wav = <explo_3.wav>;
sound explo_4_wav = <explo_4.wav>;
////////////////////////////////////////////////////////////////////////////////////
//panels
panel logodark
{
	bmap = LOGODARK_bmap;
	alpha = 0;
	layer = 4;
	flags = visible,transparent;
}
panel crosshair
{
	bmap = CROSSHAIR_bmap;
	flags = overlay;
}
panel blackmap
{
	bmap = BLACKMAP_bmap;
	scale_x = 10;
	scale_y = 10;
	layer = 3;
	alpha = 100;
	flags = visible,transparent;
}
//a close view
view camera2
{
	pos_x = 10;
	pos_y = 390;
	size_x = 190;
	size_y = 190;
	layer = 2;
}
////////////////////////////////////////////////////////////////////////////////////
//texts
text intro_t1
{
	string = "They are mean...";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 100;
	layer = 4;
	flags = visible,transparent;
}
text intro_t2
{
	string = "...They are dangerous...";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 200;
	layer = 4;
	flags = visible,transparent;
}
text intro_t3
{
	string = "...They are blood thirsty...";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 300;
	layer = 4;
	flags = visible,transparent;
}
text intro_t4
{
	string = "...They are Ducks.";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 400;
	layer = 4;
	flags = visible,transparent;
}
//loser
text end_t1
{
	string = "You failed...";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 100;
	layer = 4;
	flags = visible,transparent;
}
text end_t2
{
	string = "...To save the world...";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 200;
	layer = 4;
	flags = visible,transparent;
}
text end_t3
{
	string = "...Planet earth needs 
	another hero...";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 300;
	layer = 4;
	flags = visible,transparent;
}
text end_t4
{
	string = "...however, thanks for 
	playing DuckShoot!";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 400;
	layer = 4;
	flags = visible,transparent;
}
//winner
text end_t5
{
	string = "congratulations...";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 100;
	layer = 4;
	flags = visible,transparent;
}
text end_t6
{
	string = "...You killed enough ducks
	to survive...";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 200;
	layer = 4;
	flags = visible,transparent;
}
text end_t7
{
	string = "...You won the game...";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 300;
	layer = 4;
	flags = visible,transparent;
}
text end_t8
{
	string = "...thanks for 
	playing DuckShoot";
	font = DuckFont;
	alpha = 0;
	pos_x = 100;
	pos_y = 400;
	layer = 4;
	flags = visible,transparent;
}
panel points_pan
{
	pos_x = 10;
	pos_y = 550;
	digits = 0,0,"score: %.0f of 5000",duckfont,1,score;
	digits = 0,20,"difficulty: %.0f",duckfont,1,difficulty;
	flags = visible;
}
panel heart1
{
	bmap = HEART_bmap;
	pos_x = 400;
	pos_y = 560;
	flags = transparent;
}
panel heart2
{
	bmap = HEART_bmap;
	pos_x = 440;
	pos_y = 560;
	flags = transparent;
}
panel heart3
{
	bmap = HEART_bmap;
	pos_x = 480;
	pos_y = 560;
	flags = transparent;
}
panel heart4
{
	bmap = HEART_bmap;
	pos_x = 520;
	pos_y = 560;
	flags = transparent;
}
panel heart5
{
	bmap = HEART_bmap;
	pos_x = 560;
	pos_y = 560;
	flags = transparent;
}
////////////////////////////////////////////////////////////////////////////////////
//skies
sky sky1
{
	type = <skymap.bmp>;	
	layer = 1;
	scale_x = 2;
	scale_y = 2;
	flags = scene,dome,visible;
}
////////////////////////////////////////////////////////////////////////////////////
//functions
////////////////////////////////////////////////////////////////////////////////////
function main
{
	vec_set(sky_color.red,nullvector);
	vec_set(screen_color.red,nullvector);
	sky_color.red = 1;
	bg_color.red = 1;
	screen_color.red = 1;
	camera.fog_start = 1;
	camera.fog_end = 1;
	fog_color =1;
	wait(-1);
	media_play(song0_mid,null,100);
	music_handle =media_handle;
	while(logodark.alpha < 100)
	{
		logodark.alpha+=3*time;
		wait(1);
	}
	wait(-2);
	while(logodark.alpha > 0)
	{
		logodark.alpha-=3*time;
		wait(1);
	}
	logodark.visible = off;
	bmap_purge(LOGODARK_bmap);
	
	//fade the intro
	while(intro_t1.alpha < 100)
	{
		intro_t1.alpha +=3*time;
		wait(1);
	}
	wait(-1);
	while(intro_t2.alpha < 100)
	{
		intro_t1.alpha -=3*time;
		intro_t2.alpha +=3*time;
		wait(1);
	}
	wait(-1);
	while(intro_t3.alpha < 100)
	{
		intro_t2.alpha -=3*time;
		intro_t3.alpha +=3*time;
		wait(1);
	}
	wait(-1);
	while(intro_t4.alpha < 100)
	{
		intro_t3.alpha -=3*time;
		intro_t4.alpha +=3*time;
		wait(1);
	}
	wait(-1);
	while(intro_t4.alpha > 0)
	{
		intro_t4.alpha -=3*time;
		wait(1);
	}
	level_load("duckshoot.wmb");
	wait(2);
	camera.z = 600;
	camera.tilt = -60;
	while(camera.fog_end < 6000)
	{
		camera.fog_start +=20*time;
		camera.fog_end +=40*time;
		blackmap.alpha -= 1*time;
		camera.z-=4*time;
		camera.tilt+=0.4*time;
		wait(1);
	}
	media_stop(music_handle);
	media_play(song1_mid,null,100);
	music_handle =media_handle;
	camera.fog_end = 6000;
	camera.fog_start = 3000;
	blackmap.alpha = 0;
	loop_create_ducks();
	loop_gameover();
	loop_camera();
	crosshair.visible = on;
}
////////////////////////////////////////////////////////////////////////////////////
//particles
function part_explo_fadeout
{
	my.alpha -= 3*time;
	my.size+=0.3*time;
	if(my.alpha < 0)
	{
		my.alpha = 0;
		my.lifespan = 0;
	}
	else
	{
		my.lifespan = 1;
	}
}
function part_fire
{
	my.size = random(10)+10;
	my.vel_x = random(1)-0.5;
	my.vel_y = random(1)-0.5;
	my.vel_z = random(1)-0.5;
	my.gravity = -0.3;
	my.move = on;
	if(random(1) > 0.5){my.bright = on;}
	my.transparent = on;
	my.alpha = 20;
	my.bmap = FIRE_bmap;
	my.function = part_explo_fadeout;
}
function part_explo_small
{
	my.size = random(10)+10;
	my.vel_x = random(20)-10;
	my.vel_y = random(20)-10;
	my.vel_z = random(20)-5;
	my.gravity = 1;
	my.move = on;
	if(random(1) > 0.5){my.bright = on;}
	my.transparent = on;
	my.bmap = FIRE_bmap;
	my.function = part_explo_fadeout;
}
function part_explo
{
	my.size = random(90)+60;
	my.vel_x = random(10)-5;
	my.vel_y = random(10)-5;
	my.vel_z = random(10)-5;
	my.gravity = -0.3;
	my.move = on;
	if(random(1) > 0.5){my.bright = on;}
	my.transparent = on;
	my.bmap = FIRE_bmap;
	my.function = part_explo_fadeout;
}
function part_explo_heavy
{
	my.size = random(100)+100;
	my.vel_x = random(20)-10;
	my.vel_y = random(20)-10;
	my.vel_z = random(20)-10;
	my.gravity = -0.3;
	my.move = on;
	my.bright = on;
	my.transparent = on;
	my.bmap = FIRE_bmap;
	my.function = part_explo_fadeout;
}
function part_smoke
{
	my.size = random(90)+60;
	my.vel_x = random(10)-5;
	my.vel_y = random(10)-5;
	my.vel_z = random(10)-5;
	my.gravity = --1;
	my.move = on;
	my.transparent = on;
	my.bmap = SMOKE_BLACK_bmap;
	my.function = part_explo_fadeout;
}
function part_smoke_heavy
{
	my.size = random(100)+100;
	my.vel_x = random(20)-10;
	my.vel_y = random(20)-10;
	my.vel_z = random(20)-10;
	my.gravity = -1;
	my.move = on;
	my.transparent = on;
	my.bmap = SMOKE_BLACK_bmap;
	my.function = part_explo_fadeout;
}
action gib_act
{
	my.scale_x = 0.25+random(0.25);
	my.scale_y = 0.25+random(0.25);
	my.scale_z = 0.25+random(0.25);
	my.skill1 = 8-random(16);
	my.skill1 = 8-random(16);
	my.skill3 = 8-random(10);
	my.pan = random(360);
	my.tilt = random(360);
	my.roll = random(360);
	my.transparent = on;
	my.alpha = random(50)+50;
	while(my.alpha > 0)
	{
		vec_add(my.x,my.skill1);
		my.skill3-=0.3*time;
		my.alpha -=2*time;
		wait(1);
	}
	ent_remove(me);
}
function explo_gib(&pos)
{
	ent_create(gib_mdl,pos,gib_act);
	ent_create(gib_mdl,pos,gib_act);
	ent_create(gib_mdl,pos,gib_act);
}
////////////////////////////////////////////////////////////////////////////////////
function duck_event
{
	my.enable_shoot = off;
	ent_playsound(me,explo_3_wav,400);
	difficulty+=0.1;
	score+=4+int(difficulty)+2*int(difficulty);
	effect(part_explo,10,my.x,nullvector);
	effect(part_smoke,30,my.x,nullvector);
	effect(part_explo_small,30,my.x,nullvector);
	while(my.skill3 < 10)
	{
		camera.pan+=random(10)-5;
		camera.tilt+=random(10)-5;
		camera.roll+=random(10)-5;
		my.skill3+=4*time;
		wait(1);
	}
	my.skill2 = 0;
	wait(-0.5);
	ent_playsound(me,explo_4_wav,1800);
	effect(part_explo_heavy,30,my.x,nullvector);
	effect(part_smoke_heavy,30,my.x,nullvector);
	effect(part_explo_small,30,my.x,nullvector);
	ent_remove(me);
}
action duck_act
{
	my.flag1 = on;
	my.event = duck_event;
	my.enable_shoot = on;
	my.skin = 1+int(random(4));
	my.pan = 0;
	my.tilt = -90;
	my.skill2 = 2+difficulty/10;
	while(my.tilt < 0)
	{
		my.tilt+=10*time;
		my.z-=1*time;
		wait(1);
	}
	while(my.x > my.skill1)
	{
		my.x-=my.skill2*time;
		wait(1);
	}
	close_ent = me;
	cam2visibility+=1;
	while(my.tilt < 90)
	{
		my.tilt+=10*time;
		my.z-=1*time;
		wait(1);
	}
	cam2visibility-=1;
	lives -=1;
	wait(1);
	ent_remove(me);
}
function loop_camera
{
	while(lives > 0)
	{
		if(cam2visibility > 0){camera2.visible = on;}
		if(cam2visibility == 0){camera2.visible = off;}
		if(close_ent)
		{
			camera2.pan = 90;
			camera2.x = close_ent.x;
			camera2.y = close_ent.y-100;
			camera2.z = close_ent.z;
		}
		else
		{
			cam2visibility = 0;
			camera2.visible = off;
		}
		//normal camera
		camera.pan+=0.5*time*ang(90-camera.pan);
		camera.tilt+=0.5*time*ang(0-camera.tilt);
		camera.roll+=0.5*time*ang(0-camera.roll);
		
		wait(1);
	}
	camera2.visible = off;
}
////////////////////////////////////////////////////////////////////////////////////
//fastexplo, a faster one than c_scan
entity* starter_ent;
entity* scan_ent;
var dtne = 999999;
function fastexplo(&source,radius)
{
	var source_pos[3];
	vec_set(source_pos,source.x);
	scan_ent = ent_next(null);
	while(scan_ent != null)
	{
		result = vec_dist(scan_ent.x,source_pos.x);
		if(result < radius)
		{
			dtne = result;
			c_trace(camera.x,scan_ent.x,activate_shoot+ignore_passable+use_polygon);
		}
		scan_ent = ent_next(scan_ent);
	}
}
////////////////////////////////////////////////////////////////////////////////////
//line 2, the left one
function loop_create_ducksl2
{
	while(difficulty < 2){wait(1);}
	wait(-1);
	while(1)
	{
		temp.x = -208;
		temp.y = 736;
		temp.z = 110;
		you = ent_create(duck_mdl,temp.x,duck_act);
		your.skill1 = -524;
		wait(-7/(difficulty*0.1+1));
	}
}
//line 3, the one behind the wooden fence
function loop_create_ducksl3
{
	while(difficulty < 3){wait(1);}
	wait(-2);
	while(1)
	{
		temp.x = 474;
		temp.y = 654;
		temp.z = 110;
		you = ent_create(duck_mdl,temp.x,duck_act);
		your.skill1 = 160;
		wait(-7/(difficulty*0.1+1));
	}
}
//line 4, the one on the ground
function loop_create_ducksl4
{
	while(difficulty < 5){wait(1);}
	wait(-3);
	while(1)
	{
		temp.x = 96;
		temp.y = 400;
		temp.z = -116;
		you = ent_create(duck_mdl,temp.x,duck_act);
		your.skill1 = -225;
		wait(-7/(difficulty*0.1+1));
	}
}
//line 5, the one at the building
function loop_create_ducksl5
{
	while(difficulty < 7){wait(1);}
	wait(-4);
	while(1)
	{
		temp.x = 384;
		temp.y = 250;
		temp.z = 367;
		you = ent_create(duck_mdl,temp.x,duck_act);
		your.skill1 = 64;
		wait(-7/(difficulty*0.1+1));
	}
}
//line 1
function loop_create_ducks
{
	loop_create_ducksl2();
	loop_create_ducksl3();
	loop_create_ducksl4();
	loop_create_ducksl5();
	while(1)
	{
		temp.x = 160;
		temp.y = 760;
		temp.z = 0;
		you = ent_create(duck_mdl,temp.x,duck_act);
		your.skill1 = -160;
		wait(-7/(difficulty*0.1+1));
	}
}
////////////////////////////////////////////////////////////////////////////////////
//until game over and game over
function loop_gameover
{
	while(lives > 0)
	{
		crosshair.pos_x = pointer.x-16;
		crosshair.pos_y = pointer.y-16;
		heart1.visible = off;
		heart2.visible = off;
		heart3.visible = off;
		heart4.visible = off;
		heart5.visible = off;
		if(lives >= 1){heart1.visible = on;}
		if(lives >= 2){heart2.visible = on;}
		if(lives >= 3){heart3.visible = on;}
		if(lives >= 4){heart4.visible = on;}
		if(lives >= 5){heart5.visible = on;}
		if(mouse_middle)
		{camera.arc-= 10*time;}
		else
		{camera.arc+= 10*time;}
		camera.arc = clamp(camera.arc,20,60);
		wait(1);
	}
	if(score < 5000)
	{
		effect(part_explo_heavy,20,camera.x,nullvector);
		effect(part_smoke_heavy,30,camera.x,nullvector);
		effect(part_explo_small,50,camera.x,nullvector);
		wait(2);
		media_stop(music_handle);
		media_play(song0_mid,null,100);
		music_handle =media_handle;
		while(blackmap.alpha < 100)
		{
			blackmap.alpha+=2*time;
			camera.tilt+=1.5*time;
			camera.roll+=1.5*time;
			camera.pan+=0.5*time;
			camera.z-=1*time;
			wait(1);
		}
		while(end_t1.alpha < 100)
		{
			end_t1.alpha +=3*time;
			wait(1);
		}
		wait(-1);
		while(end_t2.alpha < 100)
		{
			end_t1.alpha -=3*time;
			end_t2.alpha +=3*time;
			wait(1);
		}
		wait(-1);
		while(end_t3.alpha < 100)
		{
			end_t2.alpha -=3*time;
			end_t3.alpha +=3*time;
			wait(1);
		}
		wait(-1);
		while(end_t4.alpha < 100)
		{
			end_t3.alpha -=3*time;
			end_t4.alpha +=3*time;
			wait(1);
		}
		wait(-1);
		while(end_t4.alpha > 0)
		{
			end_t4.alpha -=3*time;
			wait(1);
		}
	}
	else
	{
		savescore=score;
		fastexplo(nullvector,10000);//kill all ducks, and the environment
		wait(2);
		score = savescore;
		media_stop(music_handle);
		media_play(song2_mid,null,100);
		music_handle =media_handle;
		while(blackmap.alpha < 100)
		{
			blackmap.alpha+=2*time;
			wait(1);
		}
		while(end_t5.alpha < 100)
		{
			end_t5.alpha +=3*time;
			wait(1);
		}
		wait(-1);
		while(end_t6.alpha < 100)
		{
			end_t5.alpha -=3*time;
			end_t6.alpha +=3*time;
			wait(1);
		}
		wait(-1);
		while(end_t7.alpha < 100)
		{
			end_t6.alpha -=3*time;
			end_t7.alpha +=3*time;
			wait(1);
		}
		wait(-1);
		while(end_t8.alpha < 100)
		{
			end_t7.alpha -=3*time;
			end_t8.alpha +=3*time;
			wait(1);
		}
		wait(-1);
		while(end_t8.alpha > 0)
		{
			end_t8.alpha -=3*time;
			wait(1);
		}
	}
	//to win
	sys_exit("");
}
////////////////////////////////////////////////////////////////////////////////////
//to shoot
function shoot_left
{
	trace_from.x = pointer.x;
	trace_from.y = pointer.y;
	trace_from.z = 20;
	vec_for_screen(trace_from,camera);
	trace_to.x = pointer.x;
	trace_to.y = pointer.y;
	trace_to.z = 20000;
	vec_for_screen(trace_to,camera);
	c_trace(trace_from,trace_to,activate_shoot + use_polygon + ignore_passable);
	if(trace_hit == 1)
	{
		effect(part_smoke,3,target.x,nullvector);
		effect(part_explo_small,10,target.x,nullvector);
		camera.pan+=random(1)-0.5;
		camera.tilt+=random(1)-0.5;
		camera.roll+=random(1)-0.5;
	}
}
function bullet_right
{
	vec_set(temp.x,trace_to);
	vec_sub(temp.x,trace_from);
	vec_to_angle(my.pan,temp.x);
	my.passable = on;
	while(lives > 0 && me)
	{
		vec_set(temp,vector(40,0,0));
		vec_rotate(temp,my.pan);
		vec_add(temp.x,my.x);
		c_trace(my.x,temp.x,ignore_passable+activate_shoot+ignore_me + use_polygon);
		if(trace_hit == 0){vec_set(target.x,temp.x);}
		vec_set(my.x,target.x);
		if(trace_hit == 1)
		{
			effect(part_explo_heavy,5,my.x,nullvector);
			effect(part_smoke_heavy,5,my.x,nullvector);
			camera.pan+=random(4)-2;
			camera.tilt+=random(4)-2;
			camera.roll+=random(4)-2;
			fastexplo(target.x,500);
			explo_gib(my.x);
			explo_gib(my.x);
			explo_gib(my.x);
			break;
		}
		effect(part_fire,1,my.x,nullvector);
		if(my.x > 5000){break;}
		wait(1);
	}
	my.lightrange = 200;
	my.blue = 0;
	ent_playsound(me,explo_3_wav,1400);
	wait(-0.5);
	ent_playsound(me,explo_4_wav,1800);
	my.invisible = on;
	camera.pan+=random(2)-1;
	camera.tilt+=random(2)-1;
	camera.roll+=random(2)-1;
	effect(part_explo_heavy,30,my.x,nullvector);
	effect(part_smoke_heavy,30,my.x,nullvector);
	effect(part_explo_small,30,my.x,nullvector);
	wait(-1);
	ent_remove(me);
}
function shoot_right
{
	if(right_loaded < 32){return;}
	right_loaded-=32;
	trace_from.x = pointer.x;
	trace_from.y = pointer.y;
	trace_from.z = 20;
	vec_for_screen(trace_from,camera);
	trace_to.x = pointer.x;
	trace_to.y = pointer.y;
	trace_to.z = 20000;
	vec_for_screen(trace_to,camera);
	ent_create(bullet_mdl,camera.x,bullet_right);
}
function shot_event
{
	score -= 1;
	my.enable_shoot = off;
	my.ambient = -50;
	while(my.ambient > -100)
	{
		effect(part_explo,2,my.x,nullvector);
		effect(part_smoke,4,my.x,nullvector);
		effect(part_explo_small,5,my.x,nullvector);
		my.ambient -= 0.5*time;
		wait(1);
	}
	my.enable_shoot = on;
}
starter loop_shoot
{
	while(crosshair.visible == 0){wait(1);}
	//make all entities shotable
	you = ent_next(null);
	while(you != null)
	{
		your.enable_shoot = on;
		your.event = shot_event;
		you = ent_next(you);
	}
	while(lives > 0)
	{
		if(mouse_left)
		{
			shoot_left();
		}
		if(mouse_right)
		{
			shoot_right();
		}
		right_loaded+=time;
		right_loaded = clamp(right_loaded,0,32);
		wait(1);
	}
}
////////////////////////////////////////////////////////////////////////////////////
//environment:
action light_flare
{
	my.passable = on;
	vec_set(my.skill1,my.x);
	while(1)
	{
		vec_lerp(my.x,my.skill1,camera.x,0.8);
		my.scale_x = 0.1;
		my.scale_y = 0.1;
		my.scale_z = 0.1;
		my.ambient = 100;
		wait(1);
	}
}
function car_event
{
	score -= 5;
	my.enable_shoot = off;
	my.skill1 = 2;
	my.unlit = on;
	my.ambient = -50;
	while(my.ambient > -100)
	{
		effect(part_explo,1,my.x,nullvector);
		effect(part_smoke,4,my.x,nullvector);
		effect(part_explo_small,2,my.x,nullvector);
		my.ambient -= 0.5*time;
		wait(1);
	}
	my.enable_shoot = on;
}
function car_1
{
	my.pan = 180;
	my.event = car_event;
	my.enable_shoot = on;
	my.skin = 1+int(random(12));
	my.skill1 = 20;
	while(my.x > -1500)
	{
		my.x -= my.skill1*time;
		my.frame+=3*time;
		my.frame%=12;
		wait(1);
	}
	ent_remove(me);
}
function car_2
{
	my.event = car_event;
	my.enable_shoot = on;
	my.skin = 1+int(random(12));
	my.skill1 = 20;
	while(my.x < 980)
	{
		my.x += my.skill1*time;
		my.frame+=3*time;
		my.frame%=12;
		wait(1);
	}
	ent_remove(me);
}
starter traffic_cars
{
	while(crosshair.visible == off){wait(1);}
	while(1)
	{
		result = int(random(2));
		if(result == 0)
		{
			temp.x = 980;
			temp.y = 2180;
			temp.z = -128;
			ent_create(car_mdl,temp,car_1);
		}
		if(result == 1)
		{
			temp.x = -1500;
			temp.y = 2180;
			temp.z = -128;
			ent_create(car_mdl,temp,car_2);
		}
		wait(-5-random(10));
	}
}
////////////////////////////////////////////////////////////////////////////////////
//THE END!
//I knew You were going to look in this script!